#include "hash.h"
#include "basics.h"

//KIM: less fucked implementation.

t_hash hash_create ()
{
  t_hash h = (t_hash) malloc(sizeof(struct hashStr));
  h->SIZE_HASH = 0x10000;
  h->NumElem = 0;
  MemoryManager _memMgr = NULL;//createMemoryManager();
  h->hash = (t_hashNode*) calloc(h->SIZE_HASH, sizeof(t_hashNode));
  return h;
}


void hash_free(t_hash h)
{
  unsigned long i;
  t_hashNode node, tmp_node;
  for(i = 0; i < h->SIZE_HASH; i++) {
    node = h->hash[i];
    while(node != NULL) {
      tmp_node = node->next;
      free(node->word);
      free(node);
      node = tmp_node;
    };
  };
  //destroyMemoryManager(h->_memMgr);
  free(h->hash);
  //free(h->_memMgr);
  free(h);
}


static unsigned long hash_fun(const unsigned char* aWord, unsigned long len)
{
  unsigned long hash = 0;
  int c;

  while (len){
    c = *aWord++;
    len--;
    hash = c + (hash << 6) + (hash << 16) - hash;
  };

  return hash;
}
static int strcomp(const unsigned char *s1, const unsigned char *s2, unsigned long ws1, unsigned long ws2) {
	 if (ws1 != ws2) {
	 		return -1;
	 }

	 {  register unsigned long iters;
	 	 iters=1;
	    while( iters < ws1 && *s1 == *s2 )
	    {
			s1++;
			s2++;
			iters++;
	    }
	    //fprintf(stderr,"\nDevuelve [%d]",*s1-*s2);
	    return( *s1-*s2 );
	 }
}


static t_hashNode hash_find_pos(t_hash h, const unsigned char *aWord, unsigned long len, unsigned long *pos)
{
  unsigned long key = hash_fun(aWord, len);
  t_hashNode slot;
  *pos = key & (h->SIZE_HASH - 1);
  slot = h->hash[*pos];

  for(;;){
    if (slot == NULL) return NULL;
    if (strcomp(aWord, slot->word, len, slot->len) == 0)
      return slot;
    slot = slot->next;
  };

}
t_hashNode hash_find(t_hash h, const unsigned char *aWord, unsigned long len)
{
  unsigned long pos;
  return hash_find_pos(h, aWord, len, &pos);
}

static void hash_insert_slot(t_hash h, t_hashNode node, unsigned long i)
{
  t_hashNode old_node = h->hash[i];
  h->hash[i] = node;
  node->next = old_node;
}

static void resize(t_hash h)
{
  t_hashNode * old_hash;
  unsigned long old_size = h->SIZE_HASH;
  unsigned long key;
  unsigned int i;
  t_hashNode node,tmp_node;
  if ((old_size/2) < h->NumElem) {
    h->SIZE_HASH *=2;
    old_hash = h->hash;
    h->hash = (t_hashNode*) calloc(h->SIZE_HASH, sizeof(t_hashNode));
    for(i = 0; i < old_size; i++) {
      node = old_hash[i];
      while(node != NULL) {
	tmp_node = node->next;
	node->next = NULL;
	key = hash_fun(node->word, node->len);
	hash_insert_slot(h, node, key & (h->SIZE_HASH - 1));
	node = tmp_node;
      };
    };
  };

}

t_hashNode hash_add(t_hash h, const unsigned char *aWord, unsigned long len)
{
  t_hashNode node = (t_hashNode) malloc(sizeof(struct hashNode));
  unsigned int i;
  unsigned long key = 0;
  node->word = (unsigned char*) malloc(len+1);
  for(i = 0; i < len; i++)
    node->word[i] = aWord[i];
  node->word[i] = '\0';
  node->len = len;
  node->posInVoc = 0;
  node->next = NULL;
  resize(h);
  key = hash_fun(aWord, len);
  hash_insert_slot(h, node, key & (h->SIZE_HASH - 1));
  h->NumElem++;
  return node;
}

int strcompL(const byte *s1, const byte *s2, register ulong ws1, register ulong ws2) {
	register ulong iters = 0;

	while( iters<ws1 && iters<ws2 && *s1 == *s2 ){
		s1++;
		s2++;
		iters++;
	}

	if (ws1 == iters) {
			if (ws2 == ws1)
				return 0;  // s1 equals to s2
			else
				return -1;   // w1 < w2  and  *s1_i == *s2_i for i=0 to iters-1
	}
	else
	if (ws2 == iters) {
			if (ws2 == ws1)
				return 0;  // s1 equals to s2
			else
				return +1;   // w2 < w1  and  *ws1 is '\0'
	}
	else { //*s1 != *s2
		return (*s1-*s2);
	}

}
