type t = string
type level = int
val is_logger : t -> bool
val is_active : t -> bool
val level : t -> level
val activate : t -> level -> unit
val deactivate : t -> unit
val set_output : Format.formatter -> unit

val log : t -> level -> ('a, Format.formatter, unit) format -> 'a
val print : Format.formatter -> ('a, Format.formatter, unit) format -> 'a
val available : unit -> string list

