type bitmap

val bitmap_create : unit -> bitmap
val bitmap_push_back : bitmap -> int -> unit


type t

val create : bitmap -> t
external save : t -> Unix.file_descr -> unit = "caml_bp_save"
external load : Unix.file_descr -> t = "caml_bp_load"
external first_child : t -> int -> int = "caml_bp_first_child" "noalloc"
external next_sibling : t -> int -> int = "caml_bp_next_sibling" "noalloc"
external preorder_rank : t -> int -> int = "caml_bp_preorder_rank" "noalloc"

val alloc_stats : unit -> int
