let table = Hashtbl.create 103

let summary fmt =
  Hashtbl.iter (fun (m, f) d  ->
    let c, tl = !d in
    let tspent =
      List.fold_left (fun acc e -> e +. acc) 0. tl 
    in
    Format.fprintf fmt "%s: %s = called %i times, total: %fms, average: %fms\n"
      m f c tspent (tspent /. (float_of_int c))) table;
  Format.fprintf fmt "%!"
