(******************************************************************************)
(*  SXSI : XPath evaluator                                                    *)
(*  Kim Nguyen (Kim.Nguyen@nicta.com.au)                                      *)
(*  Copyright NICTA 2008                                                      *)
(*  Distributed under the terms of the LGPL (see LICENCE)                     *)
(******************************************************************************)

include FiniteCofinite.S with type elt = Tag.t and type set = Ptset.Int.t

val tag : Tag.t -> t
val pcdata : t
val attribute : t
val star : t
val node : t
val print : Format.formatter -> t -> unit
